#if !defined(win32fe_ToolFE_h_)
#define win32fe_ToolFE_h_

#include "fe.h"
#include <Windows.h>
#define UNKNOWN '*'

namespace win32fe {

  class tool {
  public:
    static int Create(win32fe::tool*&,std::string);
    void GetArgs(int argc,char *argv[]);
    virtual int Parse(void);
    virtual int Execute(void);
    virtual void Destroy(void) {delete this;}
  protected:
    tool();
    virtual ~tool();
    virtual void Help(void);

    void FoundHelp(win32fe::LI &);
    void FoundNoDetect(win32fe::LI &);
    void FoundPath(win32fe::LI &);
    void FoundUse(win32fe::LI &);
    void FoundV(win32fe::LI &);
    void FoundWoff(win32fe::LI &);
    void FoundUnknown(win32fe::LI &);
    void FoundNT4(win32fe::LI &);

    virtual void FoundFile(win32fe::LI &);
    virtual void AddSystemInfo(void);
    virtual void FindInstallation(void);
    virtual void AddPaths(void);
    virtual void DisplayVersion(void);
    virtual bool IsAKnownTool(void);

    void PrintListString(std::list<std::string> &);
    int GetShortPath(std::string &);
    int GetLongPath(std::string &,std::string &);
    void ProtectQuotes(std::string &);
    void RemoveQuotes(std::string &);
    void ReplaceSlashWithBackslash(std::string &);
    virtual void Merge(std::string &,std::list<std::string> &,win32fe::LI &);

    std::list<std::string> arg;
    std::list<std::string> file;
    std::string InstallDir;
    std::string version_string;
    bool detect;
    bool inpath;
    bool helpfound;
    bool verbose;
    bool versionfound;
    bool woff;
    bool NT4;
  private:
    std::string OptionTags;
    typedef void (win32fe::tool::*ptm)(win32fe::LI &);
    std::map<char,ptm> Options;
    HMODULE pathdll;
    FARPROC getshortpath;
    FARPROC getlongpath;
  };

}
#endif
